package ru.dbotthepony.mc.otm.screen.panels;

import com.mojang.blaze3d.vertex.PoseStack;
import net.minecraft.client.gui.components.AbstractWidget;
import net.minecraft.client.gui.screens.Screen;
import net.minecraft.network.chat.Component;
import ru.dbotthepony.mc.otm.screen.MatteryScreen;

import javax.annotation.Nonnull;
import javax.annotation.Nullable;

public class MinecraftWidgetPanel<T extends AbstractWidget> extends EditablePanel {
	public interface WidgetFactory<T extends AbstractWidget> {
		T create(MinecraftWidgetPanel<T> panel);
	}

	protected T widget;
	private final WidgetFactory<T> factory;

	public T getWidget() {
		return widget;
	}

	public MinecraftWidgetPanel(@Nonnull MatteryScreen<?> screen, @Nullable EditablePanel parent, float x, float y, float width, float height, WidgetFactory<T> factory) {
		super(screen, parent, x, y, width, height);
		this.widget = factory.create(this);
		this.factory = factory;
	}

	protected void copyValues(T new_widget, T old_widget) {

	}

	private void recreate() {
		var new_widget = factory.create(this);
		new_widget.visible = getVisible();
		new_widget.x = (int) parent_x;
		new_widget.y = (int) parent_y;
		copyValues(new_widget, widget);
		widget = new_widget;
	}

	@Override
	protected void widthUpdated(float new_value, float old_value) {
		recreate();
	}

	@Override
	protected void heightUpdated(float new_value, float old_value) {
		recreate();
	}

	@Override
	protected void visibilityChanges(boolean new_visible, boolean old_visible) {
		widget.visible = new_visible;
	}

	@Override
	protected void innerRender(PoseStack stack, float mouse_x, float mouse_y, float flag) {
		widget.render(stack, (int) mouse_x, (int) mouse_y, flag);
	}
}
